package pro.litvinovg.libreoffice.metadata.views;

import java.awt.Component;
import java.awt.event.ComponentAdapter;
import java.awt.event.ComponentEvent;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

import javax.swing.AbstractCellEditor;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.table.TableCellEditor;

public class MetadataCellEditor extends AbstractCellEditor implements TableCellEditor {
	JTextArea comp = new JTextArea();
	JTable table;
	int row;

	public MetadataCellEditor() {
		comp.setLineWrap(true);
		comp.setWrapStyleWord(true);
		comp.addComponentListener(new ComponentAdapter() {
			public void componentResized(ComponentEvent e) {
				super.componentResized(e);
				table.setRowHeight(row, (int) (comp.getPreferredSize().getHeight()));
			}
		});
		comp.addKeyListener(new KeyAdapter() {
			public void keyTyped(KeyEvent e) {
				super.keyTyped(e);
				table.setRowHeight(row, (int) (comp.getPreferredSize().getHeight()));
			}
		});
	}

	public Component getTableCellEditorComponent(JTable table, Object value, boolean isSelected, int row, int column) {
		this.table = table;
		this.row = row;

		comp.setText((String) value);
		comp.setFont(table.getFont());

		return comp;
	}

	public Object getCellEditorValue() {
		return comp.getText();
	}

}
